'  9-bit WAV Player, plays only stereo, 16-bit PCM WAV files from SD card
'  Copyright 2009 David Sloan  (With much help from Raymond Allen's
'  16-bit stereo WAV player)
'  See end of file for terms of use.  

CON 
    buffSize = 100

VAR
        long buff[buffSize]
        long bufpos
        long Samples
        long SampleRate
        long stack[40]
        byte Header[44]
        byte Playing
        byte Lp
        byte Rp    
    
OBJ
    SD  : "FSRW"
    'text : "vga_text"          'for debugging   
    SP  : "Audio Stream Player"
    
PUB start(sdpin, Lpin, Rpin) : i
  'text.start(16)
  i:=sd.mount(sdpin)
  Playing := 0
  Lp := Lpin
  Rp := RPin  

PUB Play(pString) : retval | i
  if playing == 1
    retval := -1
    'text.str(string("Already Playing"))
    'text.out($0D)
    return
  Playing := 1
  'text.out(0)
  i := sd.popen(pString, "r")
  if i <> 0
    retval := -2
    'text.str(string("Unable to open file")) 
    'text.out($0D)
    playing := 0
    return
  'text.str(string("Playing: "))
  'text.str(pString)  
  'text.out($0D)

  '**Borowed from Raymond Allen's ASM WAV Player Ver. 1b
  i:=sd.pread(@Header, 44) 'read data words to input stereo buffer
  'Get sample rate from header
  SampleRate:=Header[27]<<24+Header[26]<<16+Header[25]<<8+Header[24]
  'text.dec(SampleRate)
  'text.out(13)
  'get # samples from header
  Samples:=Header[43]<<24+Header[42]<<16+Header[41]<<8+Header[40]
  Samples:=Samples>>2
  'text.dec(Samples)
  'text.out(13)
  '****

  SP.start(Lp, Rp, @buff, buffSize, @bufpos, 80_000_000 / samplerate)
  cognew(player, @stack)

PRI player | j, n, w
  w := 0   
  n:=buffSize-1
  j:=buffsize*2   
  repeat while (j==buffsize*2 and Playing == 1)  
    if bufpos < buffsize * 2 and w == 0
      j:=sd.pread(@buff + buffsize * 2, buffSize*2) 
      w := 1
    elseif bufpos > buffsize * 2 and w == 1
      j:=sd.pread(@buff, buffsize * 2)
      w := 0   

PUB stop            
  'text.str(string("Stopped"))
  'text.out($0D)
  Playing := 0
  sp.stop
  sd.pclose

pub close
  stop
  'text.stop


  
{{
                            TERMS OF USE: MIT License

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}        